#ifndef _GLOBALCOMMAND_H
#define _GLOBALCOMMAND_H

#define sizeof_array(a) (sizeof(a)/sizeof(a[0]))

#ifndef IS_HIGH_SURROGATE
#define IS_HIGH_SURROGATE(wch)		(((wch) & 0xfc00) == 0xd800)
#define IS_LOW_SURROGATE(wch)		(((wch) & 0xfc00) == 0xdc00)
#define IS_SURROGATE_PAIR(hs, ls)	(IS_HIGH_SURROGATE(hs) && IS_LOW_SURROGATE(ls))
#endif

#ifdef UNICODE
#define IS_LEAD_TBYTE(tb)	IS_HIGH_SURROGATE(tb)
#else
#define IS_LEAD_TBYTE(tb)	IsDBCSLeadByte(tb)
#endif

#define Static_SetImage_Icon(hwndCtl, hIcon)	\
	((HICON)(UINT_PTR)SNDMSG((hwndCtl), STM_SETIMAGE, IMAGE_ICON, (LPARAM)(HICON)(hIcon)))

void mbsncpy2(unsigned char *dst,const unsigned char *src,int c);
//QoCg̐؂̂擾
long check2ByteLength(const char *szTag,long lLimit);

//DLL̃o[W擾
BOOL GetDLLVersion(IN LPCTSTR szDLLFileName,
				   IN DWORD *pdwMajor,
				   IN DWORD *pdwMinor,
				   IN DWORD *pdwBuildNumber1,
				   IN DWORD *pdwBuildNumber2);

  //Yen̂ƂTRUE
BOOL IsTailYenSign(LPCTSTR szStr);

//'\\'ǉ('\\'̂Ƃ͉Ȃ)
void AddTailYenSign(LPTSTR szStr);
void AddTailYenSign(CString &Str);

//LoadString̃oO΍(MSKB Q140452)
CString LoadResString(HINSTANCE hInstance,UINT uID);

//---------------------------------------------------------------------
//rbOGfBA->gGfBA̕ϊ
static inline DWORD ExtractI4(const unsigned char buf[4])
{
	return ((DWORD)buf[0] << 24) | ((DWORD)buf[1] << 16) | ((DWORD)buf[2] << 8) | (DWORD)buf[3];
}

static inline WORD ExtractI2(const unsigned char buf[2])
{
	return ((WORD)buf[0] << 8) | (WORD)buf[1];
}

CString getFileNameExtName(const CString &path);
CString getExtName(const CString &path);
CString getPathName(const CString &path);
CString getFileName(const CString &path);

//////////////////////////////////////////////////////////////////////////////
//getFileNameExtName
//tpXt@C擾
//////////////////////////////////////////////////////////////////////////////
/*
F	char *szPath	t@C܂ރpXւ̃|C^

߂lFchar * t@Cւ̃|C^
@@@@@@@t@C܂܂ȂƂ""ւ̃|C^
	[\],[/],[:]ȂꍇAt@CƂ݂ȂĂ̂܂ܕԂ
*/
LPCTSTR getFileNameExtName(LPCTSTR szPath);

//////////////////////////////////////////////////////////////////////////////
//getExtName
//tpXgq擾
//////////////////////////////////////////////////////////////////////////////
/*
F	char *szPath	gq܂ރpXւ̃|C^

߂lFchar * gqւ̃|C^
@@@@@@@gq܂܂ȂƂ""ւ̃|C^
*/
LPCTSTR getExtName(LPCTSTR szPath);

//VXeG[bZ[W{bNX\
void sysError(HWND hWnd,LPCTSTR mes = _T("Error"));
void errMessageBox(HWND hWnd,DWORD dwErrorCode,LPCTSTR mes = _T("Error"));

//////////////////////////////////////////////////////////////////////////////
//cutFileName
//pXt@C菜
//////////////////////////////////////////////////////////////////////////////
/*
F	char *szPath	t@C܂ރpXւ̃|C^
			isApXt@C؂藣j
߂lFȂ
*/
void cutFileName(LPTSTR szPath);

//////////////////////////////////////////////////////////////////////////////
//cutExtName
//t@Cgq菜
//////////////////////////////////////////////////////////////////////////////
/*
F	char *szFileName	t@Cւ̃|C^
			isAt@Cgq؂藣j
߂lFȂ
*/
void cutExtName(LPTSTR szFileName);

//srcw蕶cnƂɋ؂
CString divString(LPCTSTR src,char c,int n);


// Functions for encoding conversion
enum BTC_CODE {
	BTC_CODE_ANSI = 0,
	BTC_CODE_UTF16LE = 1,
	BTC_CODE_UTF16BE = 2,
	BTC_CODE_UTF8 = 3
};

// oCgCStringɕϊ
CString BytesToCString(const char *data, int size, BTC_CODE code);

// TSTRwR[h̃oCgɕϊ
int TstrToBytes(LPCTSTR tstr, int tlen, char *data, int dsize, BTC_CODE code);

// TSTRwR[h̃oCgɕϊi蓖āj
// gpfree()ŉ邱
// offset w肷ƁÃoCg]vɃmۂA
// 擪󂯂ăf[^
char *TstrToBytesAlloc(LPCTSTR tstr, int tlen, int *dsize, BTC_CODE code, int offset = 0);

// Convert UTF-16LE <-> UTF-16BE.
static inline void ConvertUTF16Endian(WCHAR *str, int len)
{
	for (int i = 0; i < len; i++)
	{
		str[i] = (str[i] << 8) | (str[i] >> 8);
	}
}

__int64 GetFileSize64(HANDLE hFile);
__int64 SetFilePointer64(HANDLE hFile,__int64 llDistanceToMove,DWORD dwMoveMethod);

static inline CString GetSizeString1(__int64 filesize)
{
	CString strSize;
	strSize.Format(_T("%I64u"),filesize);
	return divString(strSize,',',3);
}

static inline CString GetSizeStringK(__int64 filesize)
{
	CString strSize;
	__int64 fsize = (filesize + 1023) / 1024;
	strSize.Format(_T("%I64u"),fsize);
	return divString(strSize,',',3);
}

static inline CString GetSizeStringM(__int64 filesize)
{
	CString strSize;
	__int64 fsize = (filesize + 1048575) / 1048576;
	strSize.Format(_T("%I64u"),fsize);
	return divString(strSize,',',3);
}

// ^CX^vۑE
class CTimeStampSaver {
public:
	CTimeStampSaver() : m_bTimeStampPushed(FALSE) {};
	~CTimeStampSaver() {};
	BOOL Push(LPCTSTR szFile);
	BOOL Pop(LPCTSTR szFile = NULL);
	void Clear() {m_bTimeStampPushed = FALSE;};
protected:
	FILETIME	m_fileTime;	//^CX^vۑp
	FILETIME	m_createTime;	//^CX^vۑp
	BOOL		m_bTimeStampPushed;	//^CX^vۑĂ
	CString		m_strFile;
};

#endif //_GLOBALCOMMAND_H
